<?php
/**
 * Clase Base FN para BaseArArqueoDetalleValorFN
 *
 * @package    
 * @subpackage BaseArArqueoDetalleValorFN
 * @author     Willy
 * @version    SVN:: BaseArArqueoDetalleValorFN.class.php,v 1.1 2020-06-30 13:51:23 william.taype Exp $
 */
class BaseArArqueoDetalleValorFN extends ArArqueoDetalleValorBN
{
  private static $fieldNames = array (
    'Idclase'=>'idclase', 'Idsucursal'=>'idsucursal', 'Idmercado'=>'idmercado', 'Idcolaborador'=>'idcolaborador', 'Fecha'=>'fecha', 'Idvalor'=>'idvalor', 'Descripcionvalor'=>'descripcionvalor', 'Valor'=>'valor', 'Cantidad'=>'cantidad', 'Subtotal'=>'subtotal', 'Fecharegistro'=>'fecharegistro', 'Usuarioregistro'=>'usuarioregistro'  
  );

  public function select()
  {
    try
    {
      $tamPag = !property_exists($this, 'tamPag')?9999:$this->tamPag;
      $pagina = !property_exists($this, 'page')||$this->page==""?1:$this->page;
      $numeroRegistros = $this->selectNumRows();
      $limitInf = ($pagina-1)*$tamPag;

      $where = $this->buildConsult();
      $orden = $this->buildOrderByField();

      $con = Conexion::getConexion();
      $sql = "SELECT idclase, idsucursal, idmercado, idcolaborador, fecha, idvalor, descripcionvalor, valor, cantidad, subtotal, fecharegistro, usuarioregistro FROM ar_arqueo_detalle_valor WHERE 1 ".$where." ".$orden."  LIMIT ".$limitInf.",".$tamPag;
        $result = mysql_db_query(Conexion::getNameDb(), $sql, $con);
      $num_rows = mysql_num_rows($result);
      $a_tmp = array();
      if($num_rows>0){
        while ($o_valor = mysql_fetch_object($result)) {
          $a_tmp[] = $this->insertObjectBN($o_valor);
        }
      }
      
      return count($a_tmp)>0?$a_tmp:null;
    }catch ( Exception $o_Error ){
      throw new Exception($o_Error->getMessage().' en '.$o_Error->getFile().' linea '.$o_Error->getLine());
    }
  }

  public function selectNumRows()
  {
    try
    {
      $where = $this->buildConsult();

      $con = Conexion::getConexion();
      $sql = "SELECT idclase, idsucursal, idmercado, idcolaborador, fecha, idvalor, descripcionvalor, valor, cantidad, subtotal, fecharegistro, usuarioregistro FROM ar_arqueo_detalle_valor WHERE 1 ".$where;
     $result = mysql_db_query(Conexion::getNameDb(), $sql, $con);
      $num_rows = mysql_num_rows($result);
      
      return $num_rows;
    }catch ( Exception $o_Error ){
      throw new Exception($o_Error->getMessage().' en '.$o_Error->getFile().' linea '.$o_Error->getLine());
    }
  }

  public function buildConsult()
  {
    try
    {
      $where = "";

      if($this->getIdclase()){ $where .= " AND idclase = '".$this->getIdclase()."'"; }
      if($this->getIdsucursal()){ $where .= " AND idsucursal = '".$this->getIdsucursal()."'"; }
      if($this->getIdmercado()){ $where .= " AND idmercado = '".$this->getIdmercado()."'"; }
      if($this->getIdcolaborador()){ $where .= " AND idcolaborador = '".$this->getIdcolaborador()."'"; }
      if($this->getFecha()){ $where .= " AND fecha = '".$this->getFecha()."'"; }
      if($this->getIdvalor()){ $where .= " AND idvalor = '".$this->getIdvalor()."'"; }
      if($this->getDescripcionvalor()){ $where .= " AND descripcionvalor = '".$this->getDescripcionvalor()."'"; }
      if($this->getValor()){ $where .= " AND valor = '".$this->getValor()."'"; }
      if($this->getCantidad()){ $where .= " AND cantidad = '".$this->getCantidad()."'"; }
      if($this->getSubtotal()){ $where .= " AND subtotal = '".$this->getSubtotal()."'"; }
      if($this->getFecharegistro()){ $where .= " AND fecharegistro = '".$this->getFecharegistro()."'"; }
      if($this->getUsuarioregistro()){ $where .= " AND usuarioregistro = '".$this->getUsuarioregistro()."'"; }
      return $where;
    }catch ( Exception $o_Error ){
      throw new Exception($o_Error->getMessage().' en '.$o_Error->getFile().' linea '.$o_Error->getLine());
    }
  }

  public function buildOrderByField()
  {
    try
    {
      $order_by = "";

      if(property_exists($this,'sortCampos')){
      if($this->sortCampos != ""){
        $a_valCampos = explode(";", $this->sortCampos);
        $a_valtype   = explode(";", $this->sortType);
        $order_by = " ORDER BY ";
        $a_order = array();
        foreach ($a_valCampos as $key => $val){
          $sTmpOrder = "";
          if(array_key_exists($val, self::$fieldNames)){
            $sTmpOrder .= self::$fieldNames[$val];
            switch ($a_valtype[$key]){
              case 1: $sTmpOrder .= " ASC"; break;
              case 2: $sTmpOrder .= " DESC"; break;
            }
            $a_order[] = $sTmpOrder;
          }
        }
        $order_by .= implode(", ", $a_order);
      }
      }
      return $order_by;
    }catch ( Exception $o_Error ){
      throw new Exception($o_Error->getMessage().' en '.$o_Error->getFile().' linea '.$o_Error->getLine());
    }
  }

  /* B�squeda del registro por la llave primaria */
  public function selectByPK()
  {
    try
    {
      $con = Conexion::getConexion();
      $sql = "SELECT idclase, idsucursal, idmercado, idcolaborador, fecha, idvalor, descripcionvalor, valor, cantidad, subtotal, fecharegistro, usuarioregistro FROM ar_arqueo_detalle_valor WHERE 1 AND idclase='".$this->getIdclase()."' AND idsucursal='".$this->getIdsucursal()."' AND idmercado='".$this->getIdmercado()."' AND idcolaborador='".$this->getIdcolaborador()."' AND fecha='".$this->getFecha()."' AND idvalor='".$this->getIdvalor()."'; ";
        $result = mysql_db_query(Conexion::getNameDb(), $sql, $con);
      $o_Propel = $result ? mysql_fetch_object($result) : null;
      

      return $o_Propel?$this->insertObjectBN($o_Propel):null;

    }catch ( Exception $o_Error ){
      throw new Exception($o_Error->getMessage().' en '.$o_Error->getFile().' linea '.$o_Error->getLine());
    }
  }

  /* Devuelve un objeto con m�todos de acceso */
  private function insertObjectBN($o_propel){
    $o_BaseArArqueoDetalleValorFN = new BaseArArqueoDetalleValorFN();
    $o_BaseArArqueoDetalleValorFN->setIdclase($o_propel->idclase);
    $o_BaseArArqueoDetalleValorFN->setIdsucursal($o_propel->idsucursal);
    $o_BaseArArqueoDetalleValorFN->setIdmercado($o_propel->idmercado);
    $o_BaseArArqueoDetalleValorFN->setIdcolaborador($o_propel->idcolaborador);
    $o_BaseArArqueoDetalleValorFN->setFecha($o_propel->fecha);
    $o_BaseArArqueoDetalleValorFN->setIdvalor($o_propel->idvalor);
    $o_BaseArArqueoDetalleValorFN->setDescripcionvalor($o_propel->descripcionvalor);
    $o_BaseArArqueoDetalleValorFN->setValor($o_propel->valor);
    $o_BaseArArqueoDetalleValorFN->setCantidad($o_propel->cantidad);
    $o_BaseArArqueoDetalleValorFN->setSubtotal($o_propel->subtotal);
    $o_BaseArArqueoDetalleValorFN->setFecharegistro($o_propel->fecharegistro);
    $o_BaseArArqueoDetalleValorFN->setUsuarioregistro($o_propel->usuarioregistro);
    return $o_BaseArArqueoDetalleValorFN;
  }
}